package com.hz.pm.api.projectlib.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hz.pm.api.common.model.constant.BizConst;
import com.hz.pm.api.common.statemachine.event.ProjectStateChangeEvent;
import com.hz.pm.api.common.statemachine.event.TenderStateChangeEvent;
import com.hz.pm.api.projectlib.entity.PurchaseStatusChange;
import com.baomidou.mybatisplus.extension.service.IService;
import com.hz.pm.api.projectlib.model.entity.ProjectStatusChange;

import java.util.Collection;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author WendyYang
 * @since 2024-04-01
 */
public interface IPurchaseStatusChangeService extends IService<PurchaseStatusChange> {
    default PurchaseStatusChange getLastOne(String projectCode, Collection<TenderStateChangeEvent> events) {
        LambdaQueryWrapper<PurchaseStatusChange> pscQuery = Wrappers.lambdaQuery(PurchaseStatusChange.class)
                .eq(PurchaseStatusChange::getProjectCode, projectCode)
                .in(PurchaseStatusChange::getEvent, events)
                .orderByDesc(PurchaseStatusChange::getCreateOn)
                .last(BizConst.LIMIT_1);
        return getOne(pscQuery);
    }
}
